/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SnapchatLookupConnectorForm type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SnapchatLookupConnectorForm{}

// SnapchatLookupConnectorForm struct for SnapchatLookupConnectorForm
type SnapchatLookupConnectorForm struct {
	ConnectorId string `json:"connectorId"`
	TemplateId  string `json:"templateId"`
	Strategy    string `json:"strategy"`
	// Enforcing data types
	EnsureDataTypes map[string]interface{} `json:"ensureDataTypes,omitempty"`
	// OAuthId
	OAuthId string `json:"oAuthId"`
	// Data source label
	Label string `json:"label"`
	// Snapchat Organization identifier
	OrganizationId string `json:"organizationId"`
	// Snapchat Ad Account identifier
	AccountId string `json:"accountId"`
	// Level
	Level string `json:"level"`
	// Snapchat attributes
	Attribute []string `json:"attribute"`
}

// NewSnapchatLookupConnectorForm instantiates a new SnapchatLookupConnectorForm object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSnapchatLookupConnectorForm(connectorId string, templateId string, strategy string, oAuthId string, label string, organizationId string, accountId string, level string, attribute []string) *SnapchatLookupConnectorForm {
	this := SnapchatLookupConnectorForm{}
	this.ConnectorId = connectorId
	this.TemplateId = templateId
	this.Strategy = strategy
	this.OAuthId = oAuthId
	this.Label = label
	this.OrganizationId = organizationId
	this.AccountId = accountId
	this.Level = level
	this.Attribute = attribute
	return &this
}

// NewSnapchatLookupConnectorFormWithDefaults instantiates a new SnapchatLookupConnectorForm object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSnapchatLookupConnectorFormWithDefaults() *SnapchatLookupConnectorForm {
	this := SnapchatLookupConnectorForm{}
	return &this
}

// GetConnectorId returns the ConnectorId field value
func (o *SnapchatLookupConnectorForm) GetConnectorId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value
// and a boolean to check if the value has been set.
func (o *SnapchatLookupConnectorForm) GetConnectorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConnectorId, true
}

// SetConnectorId sets field value
func (o *SnapchatLookupConnectorForm) SetConnectorId(v string) {
	o.ConnectorId = v
}

// GetTemplateId returns the TemplateId field value
func (o *SnapchatLookupConnectorForm) GetTemplateId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value
// and a boolean to check if the value has been set.
func (o *SnapchatLookupConnectorForm) GetTemplateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateId, true
}

// SetTemplateId sets field value
func (o *SnapchatLookupConnectorForm) SetTemplateId(v string) {
	o.TemplateId = v
}

// GetStrategy returns the Strategy field value
func (o *SnapchatLookupConnectorForm) GetStrategy() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value
// and a boolean to check if the value has been set.
func (o *SnapchatLookupConnectorForm) GetStrategyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Strategy, true
}

// SetStrategy sets field value
func (o *SnapchatLookupConnectorForm) SetStrategy(v string) {
	o.Strategy = v
}

// GetEnsureDataTypes returns the EnsureDataTypes field value if set, zero value otherwise.
func (o *SnapchatLookupConnectorForm) GetEnsureDataTypes() map[string]interface{} {
	if o == nil || IsNil(o.EnsureDataTypes) {
		var ret map[string]interface{}
		return ret
	}
	return o.EnsureDataTypes
}

// GetEnsureDataTypesOk returns a tuple with the EnsureDataTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatLookupConnectorForm) GetEnsureDataTypesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.EnsureDataTypes) {
		return map[string]interface{}{}, false
	}
	return o.EnsureDataTypes, true
}

// HasEnsureDataTypes returns a boolean if a field has been set.
func (o *SnapchatLookupConnectorForm) HasEnsureDataTypes() bool {
	if o != nil && !IsNil(o.EnsureDataTypes) {
		return true
	}

	return false
}

// SetEnsureDataTypes gets a reference to the given map[string]interface{} and assigns it to the EnsureDataTypes field.
func (o *SnapchatLookupConnectorForm) SetEnsureDataTypes(v map[string]interface{}) {
	o.EnsureDataTypes = v
}

// GetOAuthId returns the OAuthId field value
func (o *SnapchatLookupConnectorForm) GetOAuthId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value
// and a boolean to check if the value has been set.
func (o *SnapchatLookupConnectorForm) GetOAuthIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OAuthId, true
}

// SetOAuthId sets field value
func (o *SnapchatLookupConnectorForm) SetOAuthId(v string) {
	o.OAuthId = v
}

// GetLabel returns the Label field value
func (o *SnapchatLookupConnectorForm) GetLabel() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Label
}

// GetLabelOk returns a tuple with the Label field value
// and a boolean to check if the value has been set.
func (o *SnapchatLookupConnectorForm) GetLabelOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Label, true
}

// SetLabel sets field value
func (o *SnapchatLookupConnectorForm) SetLabel(v string) {
	o.Label = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *SnapchatLookupConnectorForm) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *SnapchatLookupConnectorForm) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *SnapchatLookupConnectorForm) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetAccountId returns the AccountId field value
func (o *SnapchatLookupConnectorForm) GetAccountId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.AccountId
}

// GetAccountIdOk returns a tuple with the AccountId field value
// and a boolean to check if the value has been set.
func (o *SnapchatLookupConnectorForm) GetAccountIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.AccountId, true
}

// SetAccountId sets field value
func (o *SnapchatLookupConnectorForm) SetAccountId(v string) {
	o.AccountId = v
}

// GetLevel returns the Level field value
func (o *SnapchatLookupConnectorForm) GetLevel() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Level
}

// GetLevelOk returns a tuple with the Level field value
// and a boolean to check if the value has been set.
func (o *SnapchatLookupConnectorForm) GetLevelOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Level, true
}

// SetLevel sets field value
func (o *SnapchatLookupConnectorForm) SetLevel(v string) {
	o.Level = v
}

// GetAttribute returns the Attribute field value
func (o *SnapchatLookupConnectorForm) GetAttribute() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.Attribute
}

// GetAttributeOk returns a tuple with the Attribute field value
// and a boolean to check if the value has been set.
func (o *SnapchatLookupConnectorForm) GetAttributeOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Attribute, true
}

// SetAttribute sets field value
func (o *SnapchatLookupConnectorForm) SetAttribute(v []string) {
	o.Attribute = v
}

func (o SnapchatLookupConnectorForm) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SnapchatLookupConnectorForm) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["connectorId"] = o.ConnectorId
	toSerialize["templateId"] = o.TemplateId
	toSerialize["strategy"] = o.Strategy
	if !IsNil(o.EnsureDataTypes) {
		toSerialize["ensureDataTypes"] = o.EnsureDataTypes
	}
	toSerialize["oAuthId"] = o.OAuthId
	toSerialize["label"] = o.Label
	toSerialize["organizationId"] = o.OrganizationId
	toSerialize["accountId"] = o.AccountId
	toSerialize["level"] = o.Level
	toSerialize["attribute"] = o.Attribute
	return toSerialize, nil
}

type NullableSnapchatLookupConnectorForm struct {
	value *SnapchatLookupConnectorForm
	isSet bool
}

func (v NullableSnapchatLookupConnectorForm) Get() *SnapchatLookupConnectorForm {
	return v.value
}

func (v *NullableSnapchatLookupConnectorForm) Set(val *SnapchatLookupConnectorForm) {
	v.value = val
	v.isSet = true
}

func (v NullableSnapchatLookupConnectorForm) IsSet() bool {
	return v.isSet
}

func (v *NullableSnapchatLookupConnectorForm) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSnapchatLookupConnectorForm(val *SnapchatLookupConnectorForm) *NullableSnapchatLookupConnectorForm {
	return &NullableSnapchatLookupConnectorForm{value: val, isSet: true}
}

func (v NullableSnapchatLookupConnectorForm) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSnapchatLookupConnectorForm) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
